
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Dashboard_widgetsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const dashboard_widgets = await db.dashboard_widgets.create(
            {
                id: data.id || undefined,
        
        widget_type: data.widget_type
        ||
        null
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
        is_visible: data.is_visible
        ||
        false
        
            ,
            
        settings_json: data.settings_json
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await dashboard_widgets.setUser( data.user || null, {
            transaction,
        });
        
        await dashboard_widgets.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return dashboard_widgets;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const dashboard_widgetsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                widget_type: item.widget_type
            ||
            null
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
                is_visible: item.is_visible
            ||
            false
        
            ,
            
                settings_json: item.settings_json
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const dashboard_widgets = await db.dashboard_widgets.bulkCreate(dashboard_widgetsData, { transaction });

        // For each item created, replace relation files
        

        return dashboard_widgets;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const dashboard_widgets = await db.dashboard_widgets.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.widget_type !== undefined) updatePayload.widget_type = data.widget_type;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        if (data.is_visible !== undefined) updatePayload.is_visible = data.is_visible;
        
        
        if (data.settings_json !== undefined) updatePayload.settings_json = data.settings_json;
        
        
        updatePayload.updatedById = currentUser.id;

        await dashboard_widgets.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await dashboard_widgets.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await dashboard_widgets.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return dashboard_widgets;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const dashboard_widgets = await db.dashboard_widgets.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of dashboard_widgets) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of dashboard_widgets) {
                await record.destroy({transaction});
            }
        });


        return dashboard_widgets;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const dashboard_widgets = await db.dashboard_widgets.findByPk(id, options);

        await dashboard_widgets.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await dashboard_widgets.destroy({
            transaction
        });

        return dashboard_widgets;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const dashboard_widgets = await db.dashboard_widgets.findOne(
            { where },
            { transaction },
        );

        if (!dashboard_widgets) {
            return dashboard_widgets;
        }

        const output = dashboard_widgets.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await dashboard_widgets.getUser({
            transaction
        });
        
        
        output.organizations = await dashboard_widgets.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.settings_json) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'dashboard_widgets',
                        'settings_json',
                        filter.settings_json,
                    ),
                };
            }
            

            
            

            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.widget_type) {
                where = {
                    ...where,
                widget_type: filter.widget_type,
            };
            }
            
            if (filter.is_visible) {
                where = {
                    ...where,
                is_visible: filter.is_visible,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.dashboard_widgets.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'dashboard_widgets',
                        'widget_type',
                        query,
                    ),
                ],
            };
        }

        const records = await db.dashboard_widgets.findAll({
            attributes: [ 'id', 'widget_type' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['widget_type', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.widget_type,
        }));
    }

    
};

